#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "__fc_builtin.h"
#include "libstring.h"

#define FIXED_LEN 20

int main() {
    string_t *str, *old_char, *new_char, *result;
    char buffer[FIXED_LEN + 1];

    for (int i = 0; i < FIXED_LEN; i++) {
        buffer[i] = (char) Frama_C_interval(65, 90); // Lettres majuscules A-Z
    }
    buffer[FIXED_LEN] = '\0';

    str = string_new(buffer);
    if (!str) return 1;

    char old_c = (char) Frama_C_interval(65, 90);
    char new_c = (char) Frama_C_interval(97, 122);

    old_char = string_new(&old_c);
    new_char = string_new(&new_c);

    if (!old_char || !new_char) {
        free(str);
        return 1;
    }

    result = string_replace(str, old_char, new_char);
    if (!result) {
        free(str);
        free(old_char);
        free(new_char);
        return 1;
    }

    printf("Original: %s\n", str->buf);
    printf("Replaced: %s\n", result->buf);

    free(result);
    free(str);
    free(old_char);
    free(new_char);

    return 0;
}
